const LODASH_NAMES = [
   //// ---- axiom 
   '_un','_nu','_t','_f',
   //// ---- calc op
   '_pos',   '_neg',
   '_eq',    '_neq', '_deq',  '_ndeq',
   '_not',   '_or',  '_and',  '_xor',  "_ter",
   '_bnot',  '_bor', '_band', '_bxor',
   '_add',   '_sub', '_mul',  '_div',  '_mod','_pow',
   '_qr',    '_quo',
   '_lt',    '_le',      '_ge',   '_gt',
   '_lshft', '_rshft',   '_urshft',
   //// ---- prop op
   "_dot", "_setp" , "_del",
   '_nc',
   '_oc','_oc_call','_oc_aply',
   //// ---- word op
   "_void","_typof","_istof",
   //// ---- param op
   "_coma_fst",   "_coma_lst",
   "_pair",       "_ary", 
   //// ---- side effect op
   "_incr",       "_decr",
   //// ---- new op
   "_new_call", "_new_aply",
   //// 
   "_B","_N","_S","_BI","_Y",
   "_A","_F","_P","_X","_J","_O","_R",

   "_MP","_ST",
   "_WMP","_WST","_WREF", 

   "_RE","_DT",
   "_AB","_BUF",
   "_U8A","_U8CA","_U16A","_U32A",
   "_I8A","_I16A","_I32A",
   "_F32A","_F64A",
   "_BU64A","_BI64A", 

   "_DV", 
   "_EV","_EVT", "_EE",

   "_URL","_URLSRCHP",
        "_html_esc","_html_unesc",
       "_decd_url","_decd_url_com",
       "_encd_url","_encd_url_com",
   "_ATOM",
   //// 
   "_ER", "_AGGER", "_EVLER", "_REFER", "_RNGER", "_STXER", "_TYPER", "_URIER",

   "_FINREG",

   "_ABRT_CTRL","_ABRT_SIG",
   "_MSG_CHAN", "_MSG_PORT","_MSGEV",

   "_TXTENCD","_TXTDECD",

   "_WASM",
   ////
   "_MATH",     
   "_infi",   "_nan", "_pos_infi", "_neg_infi",
   "_is_fin", "_is_infi","_is_nan", "_is_pos_zero","_is_neg_zero", 
   "_is_ary_idx","_is_ary_len",
   "_parse_f","_parse_i",
   ////
   "_impt_meta",
   ////---- func
   "_clr_intvl","_set_intvl", 
   "_clr_tmout","_set_tmout",
   "_clr_imme", "_set_imme", 
   "_q_micro_tsk","_ntick",
   ////----
   "_prms_set_intvl", 
   "_prms_set_tmout", 
   "_prms_set_imme",  
   ////---- lib
   "_INTL","_PERF","_MOD",
   "_fslib",      "_fs_prms_lib",
   "_pathlib",    "_buflib",
   "_urlib",      "_cnslib",     "_crptlib",
   "_worklib" 
   ////----  
]


const NO_LODASH_NAMES = [
   "eval","atob","btoa","require"
]

const _fs       = require("fs");
const _path     = require("path");
const {apend_fmt_sary} = require("nv-string-basic");


const G_CODE = `const _G = globalThis;` 

const mirr     = ()=> {
    let md = {}
    for(let name of LODASH_NAMES) {
        let content = _fs.readFileSync(_path.join(__dirname,"ir",name)+".js").toString();
        content = content.replace(new RegExp(name,'g'),'');
        content = content.replace(/=/,'');
        content = content.replace(/[ \t\n]+/g,' ');
        content = content.replace(/;[ ]*$/g,'');
        content = content.trim();
        content = content.replace(/ /g,'');
        content = content.replace(/instanceof/,' instanceof ');
        content = content.replace(/delete/,'delete ');
        content = content.replace(/new/,'new ');
        if(!content.includes("delete")) {content = content.replace(/let/,'let ');}
        md[name] = content;
        md[content] = name
    }
    return(md)
}

const slct     = (ary=[])=> {
    let rslt = ary.length===0?LODASH_NAMES:[];
    for(let e of ary) {
        for(let each of LODASH_NAMES) {
            if(each.includes(e)) {
                rslt.push(each)
            }
        }
    }
    let fmted_names = apend_fmt_sary(rslt);
    let p0s      = [];
    let p1s      = [];       
    for(let i=0;i<rslt.length;i++) {
        let name = rslt[i];
        let content = _fs.readFileSync(_path.join(__dirname,"ir",name)+".js").toString();
        content = content.replace(new RegExp(name,'g'),'');
        content = content.trim();
        let arr = content.split("=>");
        if(arr.length===1) {
            arr[1] ='';
        }
        arr[0] = arr[0].trim();
        arr[0] = arr[0].replace(/[ \t\n]+/," ");
        arr[1] = arr[1].trim();
        arr[1] = arr[1].replace(/ /g,'');
        arr[1] = arr[1].replace(/instanceof/,' instanceof ');
        arr[1] = arr[1].replace(/delete/,'delete ');
        arr[1] = arr[1].replace(/new/,'new ');
        if(!arr[1].includes("delete")) {arr[1] = arr[1].replace(/let/,'let ');}    
        p0s.push(arr[0])
        p1s.push(arr[1]);
    }
    p0s = apend_fmt_sary(p0s);
    p1s = apend_fmt_sary(p1s);
    for(let i=0;i<rslt.length;i++) {
        let content = fmted_names[i] + ' ' + p0s[i];
        if(p1s[i].trim()!=='') {
            content = content + ' => ' + p1s[i]
        }
        content = '_G.'+content;
        rslt[i] = "      "+content;    
    }
    rslt.unshift(G_CODE);
    return(rslt.join("\n"))
}

const list  = ()=> {
    let arr = apend_fmt_sary(LODASH_NAMES);
    return(arr.join("\n"))
}

const DEPON_REQUIRE = {
   _EE:["_dot",["require","events"],"EventEmitter"],
   _buflib:["require","buffer"],
   _fs_prms_lib:["require","fs/promises"],
   _fslib:["require","fs"],
   _pathlib:["require","path"], 
   _urlib:["require","url"], 
   _crptlib:["require","crypto"],
   _prms_set_intvl:["_dot",["require","timers/promises"],"setInterval"],
   _prms_set_imme:["_dot",["require","timers/promises"],"setImmediate"], 
   _prms_set_tmout:["_dot",["require","timers/promises"],"setTimeout"], 
   _worklib:["require","worker_threads"]
}

module.exports = {
    LODASH_NAMES,
    NO_LODASH_NAMES,
    slct,
    list,
    mirr,
    DEPON_REQUIRE,
    quick:require("./quick")
}
